//
//  File.swift
//  NetworkApi
//
//  Created by User on 27.05.2025.
//

import Foundation

public final class NetworkProjects: NetworkProjectsProtocol {
    
    let baseUrl: BaseNetworkServiceProtocol //Create request
    
    public init(baseUrl: BaseNetworkServiceProtocol) {
        self.baseUrl = baseUrl
    }
    
    public func getProjects(token: String) async throws -> ServerProjectsResponse {
        let data = try await baseUrl.execute(path: URLS.products, method: .get, headers: Headers.headerWithToken(token: token), parameters: nil)
        return try JSONDecoder().decode(ServerProjectsResponse.self, from: data)
    }
    
    public func createProject(token: String, title: String, typeProject: String, user_id: String, dateStart: String, dateEnd:String, gender:String, description_source: String, category: String, image: String) async throws {

        let data = try await baseUrl.execute(path: URLS.projects, method: .post, headers: Headers.headerWithToken(token: token), parameters: [
            "title": title,
            "typeProject": typeProject,
            "user_id": user_id,
            "dateStart": dateStart,
            "dateEnd": dateEnd,
            "gender": gender,
            "description_source": description_source,
            "category": category,
            "image": image
        ])
    }
    
}
