//
//  File.swift
//  NetworkApi
//
//  Created by User on 27.05.2025.
//

import Foundation

public final class NetworkShop: NetworkShopProtocol {
    
    let baseUrl: BaseNetworkServiceProtocol //Create request
    
    public init(baseUrl: BaseNetworkServiceProtocol) {
        self.baseUrl = baseUrl
    }
    
    public func news(token: String) async throws -> ServerNewsResponse {
        let data = try await baseUrl.execute(path: URLS.news, method: .get, headers: Headers.headerWithToken(token: token), parameters: nil)
        return try JSONDecoder().decode(ServerNewsResponse.self, from: data)
    }
    
    public func getInfoProduct(productID: String, token: String) async throws -> ServerProductInfoResponse {
        let data = try await baseUrl.execute(path: URLS.infoProduct + productID, method: .get, headers: Headers.headerWithToken(token: token), parameters: nil)
        return try JSONDecoder().decode(ServerProductInfoResponse.self, from: data)
    }
    
    public func getProducts(token: String) async throws -> ServerProductsResponse {
        let data = try await baseUrl.execute(path: URLS.products, method: .get, headers: Headers.headerWithToken(token: token), parameters: nil)
        return try JSONDecoder().decode(ServerProductsResponse.self, from: data)
    }
    
}
