import XCTest
@testable import NetworkApi

final class NetworkApiTests: XCTestCase {
    func testExample() throws {
        // XCTest Documentation
        // https://developer.apple.com/documentation/xctest

        // Defining Test Cases and Test Methods
        // https://developer.apple.com/documentation/xctest/defining_test_cases_and_test_methods
    }
    
    func testTrueLogin() async throws {
        var baseURL: BaseNetworkService {
            let service = BaseNetworkService()
            service.baseURL = URLS.baseURL
            return service
        }
        let netwrokApi = NetworkUser(baseUrl: baseURL)
        
        let data = try await netwrokApi.login(identity: "eeeeexample@test.ru", password: "string12")
        
        XCTAssertTrue(data.token != "")
        
    }    
    func testFalseLogin() async throws {
        var baseURL: BaseNetworkService {
            let service = BaseNetworkService()
            service.baseURL = URLS.baseURL
            return service
        }
        let netwrokApi = NetworkUser(baseUrl: baseURL)
        
        let data = try await netwrokApi.login(identity: "eeeeex2ample@test.ru", password: "string12")
        
        XCTAssertFalse(data.token != "")
        
    }
    
    func testSuccessRegister() async throws {
        var baseURL: BaseNetworkService {
            let service = BaseNetworkService()
            service.baseURL = URLS.baseURL
            return service
        }
        let netwrokApi = NetworkUser(baseUrl: baseURL)
        
        let random = ["1","2","3","4","5","6","7","8","9", "10", "23"]
        
        let email = random.joined() + "example@test.ru"
        
        let data = try await netwrokApi.register(email: email, password: "register1234", passwordConfirm: "register1234", firstname: "Name", lastname: "Name", secondname: "Name", datebirthday: "", gender: "")
        
        XCTAssertTrue(!data.id.isEmpty)
        
    }
    
    func testSuccessNews() async throws {
        
        var baseURL: BaseNetworkService {
            let service = BaseNetworkService()
            service.baseURL = URLS.baseURL
            return service
        }
        let netwrokApi = NetworkShop(baseUrl: baseURL)
        
        let data = try await netwrokApi.news(token: "eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJjb2xsZWN0aW9uSWQiOiJfcGJfdXNlcnNfYXV0aF8iLCJleHAiOjE3NDg5MzY3NzcsImlkIjoiZXUyOHgxMWthbnEwOG0yIiwicmVmcmVzaGFibGUiOnRydWUsInR5cGUiOiJhdXRoIn0.H-q53wd7Y7xVlZpYfktfi8ekpxx_DJyobxCVIlLvLTo")
        
        XCTAssertTrue(!data.items.isEmpty)
        
    }
    
    func testFailedNews() async throws {
        
        var baseURL: BaseNetworkService {
            let service = BaseNetworkService()
            service.baseURL = URLS.baseURL
            return service
        }
        let netwrokApi = NetworkShop(baseUrl: baseURL)
        
        let data = try await netwrokApi.news(token: "")
        
        XCTAssertTrue(data.items.isEmpty)
        
    }
    

}
